classification
Title: TimedRotatingFileHandler permission denied rename failure on Windows
Type: crash Stage:
Components: Library (Lib) Versions: Python 2.4
process
Status: closed Resolution: works for me
Dependencies: Superseder:
Assigned To: vinay.sajip Nosy List: dnagata, vinay.sajip
Priority: normal Keywords:

Created on 2009-06-25 16:59 by dnagata, last changed 2009-07-30 07:28 by vinay.sajip. This issue is now closed.

Files
File name Uploaded Description Edit
testlog.py dnagata, 2009-06-25 17:10 repro case (fixed to remove Win32 dependencies)
Messages (4)
msg89711 - (view) Author: Dale Nagata (dnagata) Date: 2009-06-25 16:59
Traceback (most recent call last):
  File "C:\python24\lib\logging\handlers.py", line 74, in emit
    self.doRollover()
  File "C:\python24\lib\logging\handlers.py", line 271, in doRollover
    os.rename(self.baseFilename, dfn)
OSError: [Errno 13] Permission denied

originally hit on W2K3 but could not see evidence as it was running as a
service with stderr not going anywhere, but deeply suspicious since it
failed right at midnight each time. 

whittled down to bare essentials, repro'd on XP running in console
window, test case will fail in 2 min when rollover is attempted

logging set up as follows:

def initlog():
    #h = logging.handlers.TimedRotatingFileHandler( LOGFILEPATH,
'MIDNIGHT', 1, 7 )
    h = logging.handlers.TimedRotatingFileHandler( LOGFILEPATH, 'M', 2, 7 )
    h.setLevel( logging.DEBUG )
    f = logging.Formatter( '%(asctime)s %(levelname)s %(message)s',
'%Y-%m-%d %H:%M:%S' )
    h.setFormatter( f )
    logging.root.addHandler( h )
    logging.root.setLevel( logging.DEBUG )

searched issue tracker for TimedRotatingFileHandler, no hits
msg90152 - (view) Author: Vinay Sajip (vinay.sajip) * (Python committer) Date: 2009-07-05 11:43
I'm running your test script (WinXP, Python 2.5) and am unable to
reproduce the error, after running the script for a couple of hours.

Is it possible that you have e.g. anti-virus software or backup software
or some other application (e.g. a service) running in the background
which could temporarily be locking the log files? If the failure happens
repeatably on your system, try running filemon (Microsoft sysinternals)
to see system-wide file activity which could be causing the problem.
msg90153 - (view) Author: Vinay Sajip (vinay.sajip) * (Python committer) Date: 2009-07-05 11:53
See http://img15.imageshack.us/img15/5909/screenshotcpc.png which shows
the script being run.
msg91085 - (view) Author: Vinay Sajip (vinay.sajip) * (Python committer) Date: 2009-07-30 07:28
No activity for a while, closing.
History
Date User Action Args
2009-07-30 07:28:30vinay.sajipsetstatus: pending -> closed

messages: + msg91085
2009-07-07 07:11:41vinay.sajipsetstatus: open -> pending
assignee: vinay.sajip
2009-07-05 11:53:16vinay.sajipsetstatus: pending -> open

messages: + msg90153
2009-07-05 11:43:05vinay.sajipsetstatus: open -> pending

nosy: + vinay.sajip
messages: + msg90152

resolution: works for me
2009-06-25 17:10:58dnagatasetfiles: + testlog.py
2009-06-25 17:09:11dnagatasetfiles: - testlog.py
2009-06-25 16:59:44dnagatacreate